* example.prg
* multiple browse windows constantly "active"
close databases
** open databases
use custdemo
select 2
use paydemo index pay_cus
select 3
use invoice
** define the windows to use as templates
** for the BROWSE windows
define window one from 2,5 to 10,50 ;
shadow float grow zoom close
define window two from 12,5 to 22,50 ;
shadow float grow zoom close
** define a window for use as an 
** @...SAY/GET  window
define window invoice from 2,52 to 20,78 ;
shadow float close
** show the content of the @...SAY/GET window
activate window invoice
@ 1,0 get invoice
@ 2,0 get inv_date
clear gets
** show the content of the two BROWSE 
** windows
select paydemo
browse window two title "PAYDEMO" ;
nowait save
select custdemo
browse window one save ;
title "CUSTDEMO" nowait
** release the "template windows" since
** we no longer need them!
release window one,two
** establish some hotkey equivalents
on key label f2 show window custdemo top
on key label f3 show window paydemo top
on key label f4 show window invoice top
** prefill the event control message
newtop="CUSTDEMO"
do while .t.
  do case
    case newtop="CUSTDEMO"
      ** make sure the BROWSE LAST command
      ** uses the correct window!!
      select custdemo
      activate window custdemo top
      browse last
      if !wexist('custdemo')
        ** if he closed the window,
        ** exit the loop
        exit
      endif
      exitkey=readkey()
    case newtop="PAYDEMO"
      ** make sure the BROWSE LAST command
      ** uses the correct window!!
      select paydemo
      activate window paydemo top
      browse last
      if !wexist('paydemo')
        ** if he closed the window,
        ** exit the loop
        exit
      endif
      exitkey=readkey()
    case newtop="INVOICE"
      select invoice
      activate window invoice top
      @ 1,0 get invoice
      @ 2,0 get inv_date
      read
      if !wexist('INVOICE')
        ** if he closed the window,
        ** exit the loop
        exit
      endif
      ** handle situation where user last
      ** pressed [Escape] to exit the read,
      ** but now clicks on another window
      ** to exit this read. The READKEY()
      ** function incorrectly returns the
      ** code for the escape key in this
      ** circumstance, so force the value of
      ** exitkey to be 151 (mouse click) if
      ** some other window is on top!
      exitkey = iif(wontop()="INVOICE",;
      readkey(),151)
  endcase
  newtop=upper(wontop())
  do case
    case exitkey=12.or.exitkey=268
      exit
  endcase
enddo
if wexist('paydemo')
  release window paydemo
endif
if wexist('custdemo')
  release window custdemo
endif
if wexist('invoice')
  release window invoice
endif
on key label f2 
on key label f3 
on key label f4 
return

