 1 : ********************
 2 : * Name:     Setkey1.prg
 3 : * Author:   Steve Straley
 4 : * Notice:   Copyright(c) - 1990 by
 5 : *           SJS & Associates -
 6 : *           All Rights Reserved
 7 : * Date:     November 18, 1990
 8 : * Compile:  Clipper Setkey1 -m 
 9 : * Version:  Clipper Summer '87
10 : * Link:     Plink86 FI Setkey1 LIB Clipper, Extend
11 : * Note:     This shows the use the SET KEY command in
12 : *           the old days!
13 : *
14 : *******************
15 : 
16 : SET KEY 9 TO FilesOnDisk  && The 9 is the TAB key
17 : 
18 : DO WHILE .T.
19 : 
20 :    CLEAR SCREEN
21 : 
22 :    file = SPACE(40)
23 :    size = 0
24 : 
25 :    @ 1,0 SAY "Press TAB for Files!"
26 :    @ 3,0 SAY "Enter File Name: " GET file
27 :    @ 4,0 SAY "           Size: " GET size
28 :    READ
29 : 
30 :    IF LASTKEY() != 27
31 : 
32 :       @ 6,5 SAY "Values are: " GET file
33 :       @ 7,5 SAY "            " GET size
34 :       CLEAR GETS
35 :       WAIT
36 : 
37 :    ELSE
38 :       
39 :       EXIT
40 : 
41 :    ENDIF
42 : 
43 : ENDDO
44 : 
45 : ********************
46 : 
47 : FUNCTION FilesOnDisk
48 : 
49 :    PARAMETERS p, l, v
50 : 
51 :    screen = SAVESCREEN( 4,40,20,60 )
52 : 
53 :    DECLARE files[ ADIR("*.*") ]
54 :    DECLARE sizes[ LEN( files ) ]
55 : 
56 :    ADIR( "*.*", files, sizes )
57 : 
58 :    @ 4,40 TO 20,60 DOUBLE
59 : 
60 :    var = ACHOICE(5,41,19,59,files)
61 : 
62 :    IF !EMPTY(var)
63 :       IF v = "FILE"
64 :          &v. = files[var]
65 :          size = sizes[var]
66 :       ELSE
67 :          &v. = sizes[var]
68 :          file = files[var]
69 :       ENDIF
70 :    ENDIF
71 : 
72 :    RESTSCREEN( 4, 40, 20, 60, screen )
73 : 
74 :    RETURN( .F. )
75 : 
76 : * End of File

