 1 : /*
 2 :   Name:     Setkey2.prg
 3 :   Author:   Steve Straley
 4 :   Notice:   Copyright(c) - 1990 by
 5 :             SJS & Associates -
 6 :             All Rights Reserved
 7 :   Date:     November 18, 1990
 8 :   Compile:  Clipper Setkey2 /m /p /v
 9 :   Version:  Clipper 5.0
10 :   Link:     RTLink FI Setkey2 LIB Clipper, 
11 :                    Extend, Terminal, Dbfntx
12 :   Note:     This shows the use the SET KEY command in
13 :             Clipper 5.0 technology
14 :                                       */
15 : 
16 : LOCAL file, size
17 : 
18 : SETKEY( 9, {|| FilesOnDisk( @file, @size )} )
19 : 
20 : DO WHILE .T.
21 : 
22 :    CLS
23 : 
24 :    file := SPACE(40)
25 :    size := 0
26 : 
27 :    @ 1,0 SAY "Press TAB for Files!"
28 :    @ 3,0 SAY "Enter File Name: " GET file
29 :    @ 4,0 SAY "           Size: " GET size
30 :    READ
31 : 
32 :    IF LASTKEY() != 27
33 : 
34 :       @ 6,5 SAY "Values are: " GET file
35 :       @ 7,5 SAY "            " GET size
36 :       CLEAR GETS
37 :       WAIT
38 : 
39 :    ELSE
40 :       
41 :       EXIT
42 : 
43 :    ENDIF
44 : 
45 : ENDDO
46 : 
47 : ********************
48 : 
49 : FUNCTION FilesOnDisk( a, b )
50 : 
51 :    STATIC thefiles, thesizes
52 : 
53 :    LOCAL var, screen := SAVESCREEN( 4,40,20,60 )
54 : 
55 :    IF thefiles = NIL
56 :       /* both variables cannot go to the same
57 :          array pointer because they are different! */
58 : 
59 :       thefiles := {}
60 :       thesizes := {} 
61 :       AEVAL( DIRECTORY(), {|x| AADD(thefiles, x[1]), ;
62 :                                AADD(thesizes, x[2]) } )
63 :    ENDIF
64 : 
65 :    @ 4,40 TO 20,60 DOUBLE
66 : 
67 :    var := ACHOICE(5,41,19,59,thefiles)
68 : 
69 :    IF !EMPTY(var)
70 :       a := PADR( thefiles[var], 40 )
71 :       b := thesizes[var]
72 :    ENDIF
73 : 
74 :    RESTSCREEN( 4, 40, 20, 60, screen )
75 : 
76 :    RETURN( NIL )
77 : 
78 : * End of File
